=== debian/changelog ===
afl (2.49b-1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Stender <stender@debian.org>  Sat, 22 Jul 2017 14:06:01 +0200

afl (2.46b-1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Stender <stender@debian.org>  Tue, 11 Jul 2017 08:28:23 +0200

afl (2.36b-2) unstable; urgency=medium

  * bump debhelper level to 10 (deb/compat and build-dep).
  * deb/copyright:
    + use https in Format field (preferred by new standards).
    + expand copyright spans to 2017.
  * bump standards to 4.0.0 (no further changes needed).

 -- Daniel Stender <stender@debian.org>  Mon, 10 Jul 2017 20:54:10 +0200
