=== debian/control ===
Source: afl
Section: devel
Priority: optional
Maintainer: Daniel Stender <stender@debian.org>
Build-Depends:
 clang-3.9,
 debhelper (>= 10),
 dh-buildinfo,
 llvm-3.9-dev
Standards-Version: 4.0.0
Homepage: http://lcamtuf.coredump.cx/afl/
Vcs-Git: https://anonscm.debian.org/git/collab-maint/afl.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/afl.git

Package: afl
Architecture: any
Depends:
 build-essential,
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 afl-clang,
 afl-doc
Suggests:
 gnuplot
Description: instrumentation-driven fuzzer for binary formats
 American fuzzy lop is a fuzzer that employs compile-time instrumentation and
 genetic algorithms to automatically discover clean, interesting test cases
 that trigger new internal states in the targeted binary. This substantially
 improves the functional coverage for the fuzzed code. The compact synthesized
 corpora produced by the tool are also useful for seeding other, more labor- or
 resource-intensive testing regimes down the road.
 .
 afl-fuzz is designed to be practical: it has modest performance overhead, uses
 a variety of highly effective fuzzing strategies, requires essentially no
 configuration, and seamlessly handles complex, real-world use cases - say,
 common image parsing or file compression libraries.

Package: afl-clang
Architecture: any
Depends:
 afl (= ${binary:Version}),
 clang-3.9,
 ${clang:Depends},
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 afl-doc
Breaks:
 afl (<< 1.72b)
Replaces:
 afl (<< 1.72b)
Description: instrumentation-driven fuzzer for binary formats - clang support
 American fuzzy lop is a fuzzer that employs compile-time instrumentation and
 genetic algorithms to automatically discover clean, interesting test cases
 that trigger new internal states in the targeted binary.
 .
 This package provides support for the clang compiler.

Package: afl-doc
Architecture: all
Section: doc
Depends:
 ${misc:Depends}
Recommends:
 afl,
 afl-clang
Breaks:
 afl (<= 1.96b-1)
Description: instrumentation-driven fuzzer for binary formats - documentation
 American fuzzy lop is a fuzzer that employs compile-time instrumentation and
 genetic algorithms to automatically discover clean, interesting test cases
 that trigger new internal states in the targeted binary.
 .
 This package provides the documentation, a collection of special crafted test
 cases, vulnerability samples and experimental stuff.
