=== debian/changelog ===
afl (2.52b-5) unstable; urgency=medium

  * deb/control:
    + bump standards to 4.3.0 (no changes needed).
  * deb/rules:
    + don't check for flag "terse" manually.

 -- Daniel Stender <stender@debian.org>  Sun, 27 Jan 2019 13:00:29 +0100

afl (2.52b-4) unstable; urgency=medium

  * deb/rules:
    + use override for dh_install to run dh_install and stuff, not
      somewhere else (cosmetical measure).
    + let dh_strip_nondeterminism run but not on docs package.
    + add loop to set DH_VERBOSE=1 if terse tag isn't found in
      DEB_BUILD_OPTIONS (following standards 4.2.0).
  * deb/control: bump standards to 4.2.1 (no further changes).
  * deb/tests: Use AUTOPKGTEST_TMP instead of ADTTMP [Ondřej Nový].
  * build with debhelper level 11:
    + bump dh version in deb/compat.
    + bump package version in deb/control.
    + add override for dh_strip to prevent processing afl-doc in deb/rules.
    + remove deprecated --fail-missing from dh_install in deb/rules.

 -- Daniel Stender <stender@debian.org>  Mon, 29 Oct 2018 21:46:01 +0100

afl (2.52b-3) unstable; urgency=medium

  * build against llvm 6.0 (Closes: #893403).
  * deb/rules: give $CXX for llvm_mode build to prevent build break.

 -- Daniel Stender <stender@debian.org>  Wed, 08 Aug 2018 23:13:25 +0200

afl (2.52b-2) unstable; urgency=medium

  * deb/control:
    + bump standards version to 4.1.3 (no changes needed).
    + update Vcs- fields (project moved to Salsa).
  * deb/copyright:
    + expand copyright span.
  * add debian/gbp.conf.

 -- Daniel Stender <stender@debian.org>  Mon, 19 Feb 2018 19:55:08 +0100

afl (2.52b-1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Stender <stender@debian.org>  Wed, 08 Nov 2017 07:48:59 +0100

afl (2.51b-1) unstable; urgency=medium

  * New upstream release.
  * Build and run against clang/LLVM 4.0 (changes in deb/control and
    hardcode-clang-version.patch, Closes: #873404).

 -- Daniel Stender <stender@debian.org>  Tue, 17 Oct 2017 17:38:21 +0200

afl (2.50b-1) unstable; urgency=medium

  * New upstream release.
  * fix path to documentation put out by executeables:
    + add change-docpath.patch
    + adjust custom removals in deb/rules accordingly
    + changes in deb/afl-docs.install
  * add deb/afl-doc.links (installing link to README as it's pointed
    to by the tools).
  * deb/rules: add .txt to saves from dh_compress (otherwise specific pointers
    to docs from the tools mislead).

 -- Daniel Stender <stender@debian.org>  Fri, 25 Aug 2017 11:29:05 +0200
