=== debian/control ===
--- 
+++ 
@@ -3,14 +3,14 @@
 Priority: optional
 Maintainer: Daniel Stender <stender@debian.org>
 Build-Depends:
- clang-3.9,
- debhelper (>= 10),
+ clang-6.0,
+ debhelper (>= 11),
  dh-buildinfo,
- llvm-3.9-dev
-Standards-Version: 4.0.0
+ llvm-6.0-dev
+Standards-Version: 4.3.0
 Homepage: http://lcamtuf.coredump.cx/afl/
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/afl.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/afl.git
+Vcs-Git: https://salsa.debian.org/debian/afl.git
+Vcs-Browser: https://salsa.debian.org/debian/afl
 
 Package: afl
 Architecture: any
@@ -40,7 +40,7 @@
 Architecture: any
 Depends:
  afl (= ${binary:Version}),
- clang-3.9,
+ clang-6.0,
  ${clang:Depends},
  ${misc:Depends},
  ${shlibs:Depends}
